Two Rabbits HDU - 4745 (区间dp)

Two Rabbits

HDU - 4745

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai.

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise.

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise.

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone.

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time.

Now they want to find out the maximum turns they can play if they follow the optimal strategy.

Input The input contains at most 20 test cases.
For each test cases, the first line contains a integer n denoting the number of stones.
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000)
The input ends with n = 0. Output For each test case, print a integer denoting the maximum turns. Sample Input
1
1
4
1 1 2 1
6
2 1 1 2 1 3
0
Sample Output
1
4
5

        
  
Hint
For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2.
For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.

        
 

思路:这道题大意就是求最长非连续回文子串,首先求最长的回文子序列的状态转移方程比较好写

状态转移方程为 dp[i,j]=max(dp[i,j],dp[i+1,j],dp[i,j-1])

如果s[i]=s[j]   那么dp[i,j]=max(dp[i,j],dp[i+1,j-1]+2)

方法一:最后答案为两个区间的回文长度和

这种方法下我们只求区间1-n的每个子区间的最长的回文子序列,那么为什么就是两个区间长度之和呢

举个例子 1 3 3 1 9 8 9这个序列中我们可以分成两部分

1 3 3 1       9 8 9

1.........i      i+1....n

a-> <-b

扫描二维码关注公众号,回复: 915310 查看本文章

这样a向右走从1->i 再从i+1->n这样它就走了1331989,而b向左走从i->1再从n->i+1 这样他走过的还是1331989

所以长度是两段回文序列长度的和

code:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
const int maxn = 1010;
int dp[maxn][maxn];
int a[maxn];
int main(){
    int n,ans;
    while(scanf("%d",&n),n){
        memset(dp,0,sizeof(dp));
        for(int i = 1; i <= n; i++){
            scanf("%d",&a[i]);
            dp[i][i] = 1;
        }
        for(int l = 2; l <= n; l++){
            for(int i = 1; i+l-1 <= n; i++){
                int j = i + l - 1;
                dp[i][j] = max(dp[i][j],max(dp[i+1][j],dp[i][j-1]));
                if(a[i] == a[j]) dp[i][j] = max(dp[i][j],dp[i+1][j-1]+2);
            }
        }
        ans = 0;
        for(int i = 1; i <= n; i++){
            ans = max(ans,dp[1][i]+dp[i+1][n]);
        }
        printf("%d\n",ans);
    }
    return 0;
}

方法二:就是使用倍增,因为他是一个环,所以我们把数组扩展乘两倍,然后就可以找每个区间回文序列的最长长度

这样我们枚举区间长度为n的最长回文序列取最大值,这种情况下两个兔子走的方式是从回文的两端相对行走,这样跳跃的次数是回文长度,但是这种情况下枚举的都是不同起点的情况,还有相同起点的情况就枚举起点,那么剩下的部分就是找区间长度为n-1的就可以了

code:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
const int maxn = 1010;
int dp[maxn<<1][maxn<<1];
int a[maxn<<1];
int main(){
    int n,ans;
    while(scanf("%d",&n),n){
        memset(dp,0,sizeof(dp));
        for(int i = 1; i <= n; i++){
            scanf("%d",&a[i]);
            a[i+n] = a[i];
        }
        for(int i = 1; i <= 2*n; i++){
            dp[i][i] = 1;
        }
        for(int l = 1; l <= 2*n; l++){
            for(int i = 1; i+l <= 2*n; i++){
                int j = i + l;
                dp[i][j] = max(dp[i][j],max(dp[i+1][j],dp[i][j-1]));
                if(a[i] == a[j]) dp[i][j] = max(dp[i][j],dp[i+1][j-1]+2);
            }
        }
        ans = 0;
        for(int i = 1; i <= n; i++){
            ans = max(ans,dp[i][i+n-1]);
        }
        for(int i = 1; i <= n; i++){
            ans = max(ans,dp[i][i+n-2]+1);
        }
        printf("%d\n",ans);
    }
    return 0;
}




猜你喜欢

转载自blog.csdn.net/codeswarrior/article/details/80301775